#include <iostream>
using namespace std;

const int MOD = 1000000007;
int main(){

    int m; cin >> m;
    int x[m], y[m];
    int answer = 0;
    int best_x = 0;
    int best_y = 0;
    int sum_x = 0;
    int sum_y = 0;
    for(int i=0; i<m; i++){


        int val_x, val_y; cin >> val_x >> val_y;
        x[i] = val_x;
        y[i] = val_y;

        if(i==1){
            best_x = val_x;
            best_y = val_y;
        }

        bool calculate_again = false;

        sum_x += val_x;
        //sum_x %= MOD;
        if( abs(sum_x - ((i+1)*best_x)) <= abs(sum_x - ((i+1)*val_x)) ){
                best_x = val_x;
                calculate_again = true;
        }

        sum_y += val_y;
        //sum_y %= MOD;
        if( abs(sum_y - ((i+1)*best_y)) <= abs(sum_y - ((i+1)*val_y)) ){
                best_y = val_y;
                calculate_again = true;
        }
        if(calculate_again){
            answer = 0;
            for(int j=0; j<i; j++){
                answer += ( ( (abs(x[j] - best_x)) % MOD ) * ( (abs(y[j] - best_y)) % MOD ) );
                answer %= MOD;
            }

        }

        cout << (answer % MOD) << endl;

    }

}